#include "Key.hpp"
#include "EpsonScan2.h"
//#include "GetOrientation.hpp"

namespace epsonscan {

	class PDFA : public Key<SDIInt> 
	{
		public:

		explicit PDFA(IKeyDataProvider* dataProvider) : Key<SDIInt>(dataProvider)
		{

		}

		std::string GetName() const override 
		{
			return kSDIPDFAEnabledKey;
		}

		void SetValue(const SDIInt& intVal) override
        {
            current_ = intVal;
        }

		void GetValue(SDIInt& outIntVal) override
        {
			outIntVal = current_;
        }

		void GetCapability(SDICapability &capability) override
        {    
        	SetDefaultListCapability(capability);

			capability.supportLevel = kSDISupportLevelNone;
			if (SearchablePDFPlugin::IsAvailable() &&  GetOrientation::IsPluginAvailable())
			{
				capability.supportLevel = kSDISupportLevelAvailable;
			}
        }

		void Reset() override
        {
			current_ = 0;
        }

		ESDictionary GetEngineKeyValues() override
        {
            auto dict =  ESDictionary();
            return dict;
        }

		ESNumber current_;
	};

}//epsonscan